#define INCL_GPI
#define INCL_WIN
#include <os2.h>
#include <string.h>
#include <stdio.h>

MRESULT EXPENTRY ClientWndProc(HWND, ULONG, MPARAM, MPARAM);
MRESULT PaintIt(HWND);
VOID Event(HWND, PSZ);

typedef struct {
   int  rowsperscreen;
   int  colsperscreen;
   FILE *event_file;
   char *filename;
   int  horz;
   int  vert;
   int  maxhorz;
   int  check;
   } WINDOWDATA;

typedef WINDOWDATA *PWINDOWDATA;

int main (void)
{
   HAB   hab;                  /* anchor-block handle  */
   HMQ   hmq;                  /* message queue handle */
   HWND  hwndFrame, hwndClient;/* handles to windows   */
   QMSG  qmsg;                 /* message              */
   char  szClassName[] = "Events Program";
   char  szWindowTitle[] = "Events";
   ULONG flFrameOpts = (FCF_STANDARD & ~FCF_ICON &
                       ~FCF_MENU & ~FCF_ACCELTABLE)
                       | (FCF_HORZSCROLL | FCF_VERTSCROLL);


   hab = WinInitialize(0);          
   hmq = WinCreateMsgQueue(hab, 0); 
   WinRegisterClass(hab, szClassName, ClientWndProc, 
                    CS_SIZEREDRAW, sizeof (PWINDOWDATA));

   hwndFrame = WinCreateStdWindow(HWND_DESKTOP, 
        WS_VISIBLE, &flFrameOpts, szClassName, 
        szWindowTitle, 0L, 0, 0,&hwndClient);

   while (WinGetMsg(hab, &qmsg, 0, 0, 0))
      WinDispatchMsg(hab, &qmsg);
 
   WinDestroyWindow(hwndFrame);
   WinDestroyMsgQueue(hmq);
   WinTerminate(hab);
   return 0;
   }

MRESULT EXPENTRY ClientWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{                         
   char         mouse_event[1000], metype[1000];
   short        flags;
   PWINDOWDATA  wd;

   int vpos;
   MRESULT mr;

   /*event handler*/
   switch(msg) { 
  
      case WM_CREATE:
      wd = (PWINDOWDATA)calloc(1, sizeof(WINDOWDATA));
      WinSetWindowPtr(hwnd, 0, wd);
      wd->filename = strdup(tmpnam(NULL));
      wd->event_file = fopen(wd->filename, "w");
      Event(hwnd, "Create\n");
      return 0;

      case WM_DESTROY:
      Event(hwnd, "Destroy\n"); 
      wd = WinQueryWindowPtr(hwnd, 0);
      fclose(wd->event_file);      
      WinSetWindowPtr(hwnd, 0, NULL);
      return 0;

      case WM_PAINT:
/*    Event(hwnd, "Paint\n");*/
      wd = WinQueryWindowPtr(hwnd, 0);
      fflush(wd->event_file);
      return PaintIt(hwnd); 

      case WM_VSCROLL:
      wd = WinQueryWindowPtr(hwnd, 0);
      mr = WinSendMsg(
         WinWindowFromID(
         WinQueryWindow(hwnd, QW_PARENT), FID_VERTSCROLL),
         SBM_QUERYPOS, 0, 0);
      vpos = SHORT1FROMMR(mr);

      switch(SHORT2FROMMP(mp2)) {
         case SB_LINEUP:
         vpos = vpos - 1;
         break;
   
         case SB_LINEDOWN:
         vpos = vpos + 1;
         break;

         case SB_PAGEUP:
         vpos = vpos - wd->rowsperscreen;
         break;
 

         case SB_PAGEDOWN:
         vpos = vpos + wd->rowsperscreen;
         break;

         case SB_SLIDERPOSITION:
         vpos = SHORT1FROMMP(mp2);
         break;

         default: /* ignore other messages passed */
         return 0;
         }

      WinSendMsg(      
         WinWindowFromID(
         WinQueryWindow(hwnd, QW_PARENT), FID_VERTSCROLL),
         SBM_SETPOS, MPFROMSHORT(vpos), 0);

      WinInvalidateRect(hwnd, NULLHANDLE, TRUE);
      break;

/* system messages */
      case WM_ACTIVATE:
      if (SHORT1FROMMP(mp1)) Event(hwnd, "Activated\n");
      else Event(hwnd, "Deactivated\n"); 
      break;

/* keyboard messages */
      case WM_CHAR:
      Event(hwnd,"Key: ");
      flags = SHORT1FROMMP(mp1);
 
      /* basic key info */
      if (flags & KC_KEYUP) Event(hwnd, "Up ");
      else if (flags & KC_PREVDOWN) Event(hwnd, "Auto ");
      else Event(hwnd, "Down ");
      if (flags & KC_LONEKEY) Event(hwnd, "- Lone Key - ");
 
      /* which key */
      if (flags & KC_VIRTUALKEY)
      switch(SHORT2FROMMP(mp2)) {
         case VK_ALT:       Event(hwnd, "(Alt) "); break;
         case VK_ALTGRAF:   Event(hwnd, "(AltGraf) "); break;
         case VK_BREAK:     Event(hwnd, "(Break) "); break;
         case VK_CAPSLOCK:  Event(hwnd, "(Caps Lock) "); break;
         case VK_CTRL:      Event(hwnd, "(Ctrl) "); break;
         case VK_DELETE:    Event(hwnd, "(Delete) "); break;
         case VK_DOWN:      Event(hwnd, "(Down) "); break;
         case VK_BACKSPACE: Event(hwnd, "(Backspace) "); break;
         case VK_BACKTAB:   Event(hwnd, "(BackTab) "); break;
         case VK_END:       Event(hwnd, "(End) "); break;
         case VK_ENTER:     Event(hwnd, "(Enter) "); break;
         case VK_ESC:       Event(hwnd, "(Esc) "); break;
         case VK_F1:        Event(hwnd, "(F1) "); break;         
         case VK_F2:        Event(hwnd, "(F2) "); break;
         case VK_F3:        Event(hwnd, "(F3) "); break;
         case VK_F4:        Event(hwnd, "(F4) "); break;
         case VK_F5:        Event(hwnd, "(F5) "); break;
         case VK_F6:        Event(hwnd, "(F6) "); break;
         case VK_F7:        Event(hwnd, "(F7) "); break;
         case VK_F8:        Event(hwnd, "(F8) "); break;
         case VK_F9:        Event(hwnd, "(F9) "); break;
         case VK_F10:       Event(hwnd, "(F10) "); break;
         case VK_F11:       Event(hwnd, "(F11) "); break;
         case VK_F12:       Event(hwnd, "(F12) "); break;
         case VK_HOME:      Event(hwnd, "(Home) "); break;
         case VK_INSERT:    Event(hwnd, "(Insert) "); break;
         case VK_LEFT:      Event(hwnd, "(Left) "); break;
         case VK_NEWLINE:   Event(hwnd, "(Enter) "); break;
         case VK_NUMLOCK:   Event(hwnd, "(Num Lock) "); break;
         case VK_PAGEDOWN:  Event(hwnd, "(Page Down) "); break;
         case VK_PAGEUP:    Event(hwnd, "(Page Up) "); break;
         case VK_PAUSE:     Event(hwnd, "(Pause) "); break; 
         case VK_PRINTSCRN: Event(hwnd, "(Print Screen) "); break;
         case VK_RIGHT:     Event(hwnd, "(Right) "); break;
         case VK_SCRLLOCK:  Event(hwnd, "(Scroll Lock) "); break;
         case VK_SHIFT:     Event(hwnd, "(Shift) "); break;
         case VK_SPACE:     Event(hwnd, "(Space) "); break;
         case VK_SYSRQ:     Event(hwnd, "(Sys Rq) "); break;
         case VK_TAB:       Event(hwnd, "(Tab) "); break;
         case VK_UP:        Event(hwnd, "(Up) "); break;
      } else {
         metype[0] = '"';
         metype[1] = SHORT1FROMMP(mp2);
         metype[2] = '"';
         metype[3] = ' ';
         metype[4] = '\0';
         Event(hwnd, metype); 
         }

      sprintf(metype, " Reps: #%d", CHAR3FROMMP(mp1));
      Event(hwnd, metype);

      if (flags & KC_SHIFT) Event(hwnd, " -> Shift");
      if (flags & KC_CTRL) Event(hwnd, " -> Ctrl");
      if (flags & KC_ALT) Event(hwnd, " -> Alt");

      Event(hwnd, "\n");                
      break;

/* task messages */
      case WM_BEGINDRAG:
      case WM_ENDDRAG:
      case WM_SINGLESELECT:
      case WM_BEGINSELECT:
      case WM_ENDSELECT:
      case WM_OPEN:
      case WM_TEXTEDIT:
      case WM_CONTEXTMENU:

      switch(msg) {
         case WM_BEGINDRAG      : strcpy(metype, "Begin Drag"); break;
         case WM_ENDDRAG        : strcpy(metype, "End Drag"); break;
         case WM_SINGLESELECT   : strcpy(metype, "Single Select"); break;
         case WM_BEGINSELECT    : strcpy(metype, "Begin Select"); break;
         case WM_ENDSELECT      : strcpy(metype, "End Select"); break;
         case WM_OPEN           : strcpy(metype, "Open"); break;
         case WM_TEXTEDIT       : strcpy(metype, "Text Edit"); break;
         case WM_CONTEXTMENU    : strcpy(metype, "Context Menu");break;
         }

      sprintf(mouse_event, "%s at %d, %d\n", metype,
                SHORT1FROMMP(mp1),
                SHORT2FROMMP(mp1));
      Event(hwnd, mouse_event);
      break;

/* mouse messages */

      case WM_BUTTON1DOWN:
      case WM_BUTTON1CLICK:
      case WM_BUTTON1DBLCLK:
      case WM_BUTTON1UP:
      case WM_BUTTON1MOTIONSTART:
      case WM_BUTTON1MOTIONEND:

      case WM_BUTTON2DOWN:
      case WM_BUTTON2CLICK:
      case WM_BUTTON2DBLCLK:
      case WM_BUTTON2UP:
      case WM_BUTTON2MOTIONSTART:
      case WM_BUTTON2MOTIONEND:

      switch(msg) {
         case WM_BUTTON1DOWN       : strcpy(metype, "Button 1 down"); break;
         case WM_BUTTON1CLICK      : strcpy(metype, "Button 1 click"); break;
         case WM_BUTTON1DBLCLK     : strcpy(metype, "Button 1 double-click"); break;
         case WM_BUTTON1UP         : strcpy(metype, "Button 1 up"); break;
         case WM_BUTTON1MOTIONSTART: strcpy(metype, "Button 1 motion start"); break;
         case WM_BUTTON1MOTIONEND  : strcpy(metype, "Button 1 motion end"); break;

         case WM_BUTTON2DOWN       : strcpy(metype, "Button 2 down"); break;
         case WM_BUTTON2CLICK      : strcpy(metype, "Button 2 click"); break;
         case WM_BUTTON2DBLCLK     : strcpy(metype, "Button 2 double-click"); break;
         case WM_BUTTON2UP         : strcpy(metype, "Button 2 up"); break;
         case WM_BUTTON2MOTIONSTART: strcpy(metype, "Button 2 motion start"); break;
         case WM_BUTTON2MOTIONEND  : strcpy(metype, "Button 2 motion end"); break;
         }                                                                

      sprintf(mouse_event, "%s at %d, %d\n", metype,
                SHORT1FROMMP(mp1),
                SHORT2FROMMP(mp1));
      Event(hwnd, mouse_event);
      break;
 
/* user messages */
      default:
      break;
      }
   /*end event handlers */

   return WinDefWindowProc(hwnd, msg, mp1, mp2);
   }

VOID Event(HWND hwnd, PSZ msg)
{    
   SHORT        currentv, currenth;
   HWND         frame, sbh, sbv;
   PWINDOWDATA  wd;

   wd = WinQueryWindowPtr(hwnd, 0);
   frame = WinQueryWindow(hwnd, QW_PARENT);
   sbh = WinWindowFromID(frame, FID_HORZSCROLL);
   sbv = WinWindowFromID(frame, FID_VERTSCROLL); 
   currenth = SHORT1FROMMR(WinSendMsg(sbh, SBM_QUERYPOS, 0,0));
   currentv = SHORT1FROMMR(WinSendMsg(sbv, SBM_QUERYPOS, 0,0));

   wd->horz = wd->horz + strlen(msg);
   /* if this is a new line, calculate the largest text
      line passed and see if we should expand the range 
      of the horizontal scroll bar.
      Expand the range of the vertical scroll bar*/

   if (msg[strlen(msg)-1]=='\n') {
      wd->vert = wd->vert + 1;
      wd->horz = wd->horz - 1; /* subtract out new line character */
      if (wd->horz > wd->maxhorz) wd->maxhorz = wd->horz;
      wd->horz = 0;

      WinSendMsg(sbh, SBM_SETSCROLLBAR, 
                MPFROMSHORT(currenth),
                MPFROM2SHORT(1, wd->maxhorz));
      WinSendMsg(sbh, SBM_SETTHUMBSIZE,
                MPFROM2SHORT(wd->colsperscreen, wd->maxhorz),
                MPFROMSHORT(0));

      WinSendMsg(sbv, SBM_SETSCROLLBAR,
                MPFROMSHORT(currentv),
                MPFROM2SHORT(1, wd->vert));
      WinSendMsg(sbv, SBM_SETTHUMBSIZE,
                MPFROM2SHORT(wd->rowsperscreen, wd->vert),
                MPFROMSHORT(0));
      } 

   if (wd->event_file != NULL)
   {
      fputs(msg, wd->event_file);
      WinInvalidateRect(hwnd, NULL, FALSE);
      }
   }           

MRESULT PaintIt(HWND hwnd)
{
   HPS          hps;
   RECTL        rcl;
   LONG         charHeight;
   FONTMETRICS  fontMetrics;
   FILE         *paint_file;
   char         event_description[1000];

   SWP          swp;
   int          currentline, hpos, vpos;
   HWND         frame;
   MRESULT      mr;
   PWINDOWDATA  wd;

      wd = WinQueryWindowPtr(hwnd, 0);
      fclose(wd->event_file);/* necessary for IBM CSET++ */
      paint_file = fopen(wd->filename, "r");

      hps = WinBeginPaint(hwnd, NULLHANDLE, NULLHANDLE);
      WinQueryWindowRect(hwnd, &rcl);
      WinFillRect(hps, &rcl, CLR_WHITE);
      GpiQueryFontMetrics(hps, sizeof(fontMetrics), &fontMetrics);
      charHeight = fontMetrics.lMaxBaselineExt;

      if (paint_file!=NULL) {

         WinQueryWindowPos(hwnd, &swp);
         wd->rowsperscreen = swp.cy / charHeight;
         wd->colsperscreen = swp.cx / fontMetrics.lEmInc;

         rcl.yBottom = rcl.yTop-charHeight;

         frame = WinQueryWindow(hwnd, QW_PARENT);
         mr = WinSendMsg(
                WinWindowFromID(frame, FID_HORZSCROLL),
                SBM_QUERYPOS, 0,0);
         hpos = SHORT1FROMMR(mr);
         mr = WinSendMsg(
                WinWindowFromID(frame, FID_VERTSCROLL),
                SBM_QUERYPOS, 0,0);
         vpos = SHORT1FROMMR(mr);

         currentline = 0;
         do {
            currentline = currentline + 1;
            fgets(event_description, 1000, paint_file);
            if (feof(paint_file)) break;
            if (currentline<vpos) continue;
            if (hpos>strlen(event_description)) continue;
            WinDrawText(hps, strlen(event_description)-1, event_description, &rcl, 0, 0, DT_TEXTATTRS);
            rcl.yTop = rcl.yTop - charHeight;
            rcl.yBottom = rcl.yBottom - charHeight;
            } while (rcl.yBottom >= 0);
 
         fclose(paint_file);
         }
      wd->event_file = fopen(wd->filename, "a");
      WinEndPaint(hps);
                                 
      return 0;
      }
