#define INCL_GPI
#define INCL_WIN
#include <os2.h>
#include <string.h>
#include <menu2.h>

MRESULT EXPENTRY ClientWndProc(HWND, ULONG, MPARAM, MPARAM);

int main (void)
{
   HAB   hab;                    /* anchor-block handle  */
   HMQ   hmq;                    /* message queue handle */
   HWND  hwndFrame, hwndClient;  /* handles to windows   */
   QMSG  qmsg;                   /* message              */
   char  szClassName[] = "Menus ][";
   char  szWindowTitle[] = "Menus ][";
   ULONG flFrameOpts = FCF_STANDARD;

   hab = WinInitialize(0);          
   hmq = WinCreateMsgQueue(hab, 0); 
   WinRegisterClass(hab, szClassName, ClientWndProc, 
                    CS_SIZEREDRAW, 0);

   hwndFrame = WinCreateStdWindow(HWND_DESKTOP, WS_VISIBLE,
                                 &flFrameOpts, szClassName,
                                 szWindowTitle, 0L, 0, 
                                 MENU2PROGRAMID,
                                 &hwndClient);

   while (WinGetMsg(hab, &qmsg, 0, 0, 0))
      WinDispatchMsg(hab, &qmsg);
 
   WinDestroyWindow(hwndFrame);
   WinDestroyMsgQueue(hmq);
   WinTerminate(hab);
   return 0;
   }

MRESULT EXPENTRY ClientWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{                         
   HPS   hps;
   RECTL rcl;            
   static char text[] = "Enough space to accomodate new messages.";
   ULONG displayOpts = DT_TEXTATTRS | DT_CENTER  | DT_VCENTER;
   HWND menu, frame;
   BOOL newstatus;

   /*event handler*/
   switch(msg) { 
      case WM_PAINT:

      hps = WinBeginPaint(hwnd, NULLHANDLE, NULLHANDLE);
      WinQueryWindowRect(hwnd, &rcl);
      WinFillRect(hps, &rcl, CLR_BACKGROUND);
      GpiSetBackMix(hps, BM_OVERPAINT);
      WinDrawText(hps, -1, text, &rcl, 0,0, displayOpts);
      WinEndPaint(hps);

      return 0;

      case WM_COMMAND:

      frame = WinQueryWindow(hwnd, QW_PARENT);
      menu = WinWindowFromID(frame, FID_MENU);
      
      switch(SHORT1FROMMP(mp1)) {

         case CMD_COMMAND: 
         strcpy(text, "Command!");
         break;

         case CMD_CHECK:
         if (WinSendMsg(menu, MM_QUERYITEMATTR,
            MPFROM2SHORT(CMD_CHECK, TRUE),
            MPFROM2SHORT(MIA_CHECKED, 0)))
         {                                
            strcpy(text, "Unchecked!");
            newstatus = 0;
            }
         else {                           
           strcpy(text, "Checked!");
           newstatus = MIA_CHECKED;
           }

         WinSendMsg(menu, MM_SETITEMATTR,
            MPFROM2SHORT(CMD_CHECK, TRUE),
            MPFROM2SHORT(MIA_CHECKED, newstatus)); 
         break;

         case CMD_STICK:
         strcpy(text, "Sticky!");
         break;
 
         case CMD_DISABLE:
         strcpy(text, "Disabling menu item.");
         WinSendMsg(menu, MM_SETITEMATTR,
            MPFROM2SHORT(CMD_VARIABLE, TRUE),
            MPFROM2SHORT(MIA_DISABLED, MIA_DISABLED));
         break;

         case CMD_ENABLE:
         strcpy(text, "Enabling menu item.");
         WinSendMsg(menu, MM_SETITEMATTR,
            MPFROM2SHORT(CMD_VARIABLE, TRUE),
            MPFROM2SHORT(MIA_DISABLED, 0));
         break;

         case CMD_VARIABLE:
         strcpy(text, "Variable: Item sometimes disabled.");
         break;
         }

      WinInvalidateRect(hwnd, NULL, FALSE);
      break;
      }

   /*end event handlers */

   return WinDefWindowProc(hwnd, msg, mp1, mp2);
   }
