#define INCL_GPI
#define INCL_WIN
#include <os2.h>
#include <string.h>


MRESULT EXPENTRY ClientWndProc(HWND, ULONG, MPARAM, MPARAM);

int main (void)
{
   HAB   hab;                    /* anchor-block handle  */
   HMQ   hmq;                    /* message queue handle */
   HWND  hwndFrame, hwndClient;  /* handles to windows   */
   QMSG  qmsg;                   /* message              */
   char  szClassName[] = "Pointer Test";
   char  szWindowTitle[] = "Pointers";
   ULONG flFrameOpts = FCF_STANDARD & ~FCF_ICON &  
                       ~FCF_MENU & ~FCF_ACCELTABLE;


   hab = WinInitialize(0);          
   hmq = WinCreateMsgQueue(hab, 0); 
   WinRegisterClass(hab, szClassName, ClientWndProc, 
                    CS_SIZEREDRAW, 0);

   hwndFrame = WinCreateStdWindow(HWND_DESKTOP, WS_VISIBLE,
                                 &flFrameOpts, szClassName,
                                 szWindowTitle, 0L, 0, 0,
                                 &hwndClient);

   while (WinGetMsg(hab, &qmsg, 0, 0, 0))
      WinDispatchMsg(hab, &qmsg);
 
   WinDestroyWindow(hwndFrame);
   WinDestroyMsgQueue(hmq);
   WinTerminate(hab);
   return 0;
   }

MRESULT EXPENTRY ClientWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{                         
   HPS    hps;
   RECTL  rcl;
   static HPOINTER hptr = NULLHANDLE;

   /*event handler*/
   switch(msg) {

      case WM_PAINT:
      hps = WinBeginPaint(hwnd, NULLHANDLE, NULLHANDLE);
      WinQueryWindowRect(hwnd, &rcl);
      WinFillRect(hps, &rcl, CLR_WHITE);
      WinEndPaint(hps);
      return 0;

      case WM_BUTTON1DOWN:
      if (hptr) WinDestroyPointer(hptr);
      hptr = WinLoadPointer(HWND_DESKTOP, 0, 10);
      WinSetPointer(HWND_DESKTOP, hptr);
      return 0;

      case WM_BUTTON2DOWN:
      if (hptr) WinDestroyPointer(hptr);
      hptr = WinQuerySysPointer(HWND_DESKTOP, SPTR_WAIT, FALSE);
      WinSetPointer(HWND_DESKTOP, hptr);
      return 0;

      case WM_MOUSEMOVE:
      if (hptr) WinSetPointer(HWND_DESKTOP, hptr);
      return 0;
      }
   /*end event handlers */

   return WinDefWindowProc(hwnd, msg, mp1, mp2);
   }
