#define INCL_GPI
#define INCL_WIN
#include <os2.h>
#include <string.h>

#include "basic2.h"

MRESULT EXPENTRY ClientWndProc(HWND, ULONG, MPARAM, MPARAM);

#define APPNORMAL    0
#define INITFAILURE -1
#define USERQUIT    -2

int main (void)
{
   HAB   hab;                    /* anchor-block handle  */
   HMQ   hmq;                    /* message queue handle */
   HWND  hwndFrame, hwndClient;  /* handles to windows   */
   QMSG  qmsg;                   /* message              */
   char  szClassName[] = "Standard Dialog Window";
   char  szWindowTitle[] = "File and Font Dialogs";
   ULONG flFrameOpts = FCF_STANDARD;
   ULONG appState = APPNORMAL;
 
   hab = WinInitialize(0);
   hmq = WinCreateMsgQueue(hab, 0);

   if (!WinRegisterClass(hab, szClassName, ClientWndProc,
                    CS_SIZEREDRAW, 0)) 
             appState = INITFAILURE;
   hwndFrame = WinCreateStdWindow(HWND_DESKTOP, WS_VISIBLE,
                                &flFrameOpts, szClassName,
                                szWindowTitle, 0L, 0, 
                                BASIC2PROGRAMID,
                                &hwndClient);

   if ((appState==INITFAILURE) || (hab==NULLHANDLE) ||
       (hmq==NULLHANDLE) || (hwndFrame==NULLHANDLE))
       WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
              "Unable to initialize application.", "ERROR!",
              0, MB_CANCEL | MB_ERROR);
   else 
   while (appState==APPNORMAL) {

      while (WinGetMsg(hab, &qmsg, 0, 0, 0))
      WinDispatchMsg(hab, &qmsg);

      if (WinSendMsg(hwndClient, WM_COMMAND, 
         MPFROM2SHORT(CMD_VERIFY, 0), 0) != MBID_CANCEL)
         appState = USERQUIT;

      if (qmsg.hwnd == NULLHANDLE) /*system shutdown */
         if (appState != USERQUIT) WinCancelShutdown(hmq, FALSE);

      }

   WinDestroyWindow(hwndFrame);
   WinDestroyMsgQueue(hmq);
   WinTerminate(hab);
   
   return 0;
   }

MRESULT EXPENTRY ClientWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{                         
   HPS     hps;
   RECTL   rcl;
   ULONG   cmd;

   HWND    fdlg;
   FILEDLG fd;  
   char    fdTitle[] = "Sample File Dialog";

   /*event handler*/
   switch(msg) {

      case WM_PAINT:
      hps = WinBeginPaint(hwnd, NULLHANDLE, NULLHANDLE);
      WinQueryWindowRect(hwnd, &rcl);
      WinFillRect(hps, &rcl, CLR_WHITE);
      WinEndPaint(hps);
      return 0;

      case WM_BUTTON1CLICK:
      memset(&fd, 0, sizeof(FILEDLG));
      fd.cbSize = sizeof(FILEDLG);
      fd.fl = FDS_CENTER | FDS_SAVEAS_DIALOG;
      strcpy(fd.szFullFile, "*.*");
      fd.pszTitle = fdTitle;       
      fdlg = WinFileDlg(HWND_DESKTOP, hwnd, &fd);
      if (fdlg && (fd.lReturn == DID_OK))
         WinMessageBox(HWND_DESKTOP, hwnd,
              fd.szFullFile, "File Selected", 0, 0);
      break;

      case WM_COMMAND:
      switch(SHORT1FROMMP(mp1)) {
         case CMD_VERIFY:
         cmd = MBID_NO;                                
         /* if (data_modified) */ {
            cmd = WinMessageBox(HWND_DESKTOP, hwnd,
                "Do you want to save your work before exiting?",
                "Query", 0, MB_YESNOCANCEL | MB_QUERY);
            /* if cmd==MB_YES save_data */
            } 
         return (MRESULT)cmd;
 
         /* case CMD_OTHERCOMMANDS: */

         } /* end WM_COMMAND messages */

      } /*end event handlers */
   return WinDefWindowProc(hwnd, msg, mp1, mp2);
   }
