#define INCL_GPI
#define INCL_WIN
#include <os2.h>
#include <string.h>

#include "dialog.h"

MRESULT EXPENTRY ClientWndProc(HWND, ULONG, MPARAM, MPARAM);
MRESULT EXPENTRY DialogProc(HWND, ULONG, MPARAM, MPARAM);

#define APPNORMAL    0
#define INITFAILURE  1
#define USERQUIT     2

int main (void)
{
   HAB   hab;                    /* anchor-block handle  */
   HMQ   hmq;                    /* message queue handle */
   HWND  hwndFrame, hwndClient;  /* handles to windows   */
   QMSG  qmsg;                   /* message              */
   char  szClassName[] = "Dialog Program";
   char  szWindowTitle[] = "Dialogs, etc.";
   ULONG flFrameOpts = FCF_STANDARD;
   ULONG appState = APPNORMAL;

   hab = WinInitialize(0);
   hmq = WinCreateMsgQueue(hab, 0);

   if (!WinRegisterClass(hab, szClassName, ClientWndProc,
		    CS_SIZEREDRAW, 0))
	     appState = INITFAILURE;
   hwndFrame = WinCreateStdWindow(HWND_DESKTOP, WS_VISIBLE,
				&flFrameOpts, szClassName,
				szWindowTitle, 0L, 0,
				DIALOGPROGRAMID,
				&hwndClient);


   if ((appState==INITFAILURE) || (hab==NULLHANDLE) ||
       (hmq==NULLHANDLE) || (hwndFrame==NULLHANDLE))
       WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
              "Unable to initialize application.", "ERROR!",
              0, MB_CANCEL | MB_ERROR);
   else
   while (appState==APPNORMAL) {

      while (WinGetMsg(hab, &qmsg, 0, 0, 0))
      WinDispatchMsg(hab, &qmsg);

      if (WinSendMsg(hwndClient, WM_COMMAND, 
	 MPFROM2SHORT(CMD_VERIFY, 0), 0) != MBID_CANCEL)
         appState = USERQUIT;

      if (qmsg.hwnd == NULLHANDLE) /*system shutdown */
	 if (appState != USERQUIT) WinCancelShutdown(hmq, FALSE);

      }

   WinDestroyWindow(hwndFrame);
   WinDestroyMsgQueue(hmq);
   WinTerminate(hab);
   
   return 0;
   }

MRESULT EXPENTRY ClientWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   HPS    hps;
   RECTL  rcl;
   ULONG  cmd;
   static char data[1000] = "Initial Data";

   /*event handler*/
   switch(msg) {

      case WM_PAINT:
      hps = WinBeginPaint(hwnd, NULLHANDLE, NULLHANDLE);
      WinQueryWindowRect(hwnd, &rcl);
      WinFillRect(hps, &rcl, CLR_WHITE);
      WinDrawText(hps, -1, data, &rcl, 0,0, 
             DT_TEXTATTRS | DT_CENTER | DT_VCENTER);
      WinEndPaint(hps);
      return 0;

      case WM_COMMAND:

      switch(SHORT1FROMMP(mp1)) {
	 case CMD_FILEOPEN:
	 if (WinDlgBox(HWND_DESKTOP, hwnd, DialogProc, 0,
		    BAREDIALOGID, data)==DID_OK)
            WinInvalidateRect(hwnd, NULLHANDLE, TRUE);
	 break;

	 case CMD_VERIFY:
	 cmd = MBID_NO;
	 /* if (data_modified) */ {
	    cmd = WinMessageBox(HWND_DESKTOP, hwnd,
		"Do you want to save your work before exiting?",
		"Query", 0, MB_YESNOCANCEL | MB_QUERY);
	    /* if cmd==MB_YES save_data */
	    }
	 return (MRESULT)cmd;

	 /* case CMD_OTHERCOMMANDS: */

	 } /* end WM_COMMAND messages */

      } /*end event handlers */
   return WinDefWindowProc(hwnd, msg, mp1, mp2);
   }

MRESULT EXPENTRY DialogProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{      
   HWND effect, data;
   BOOL enabled;
   static char local[1000];
   static char* client;

   switch(msg) {

      case WM_INITDLG:  
      client = mp2;
      strcpy(local, client);
      data = WinWindowFromID(hwnd, EF_DATA);
      WinSetWindowText(data, local);
      break;
 
      case WM_COMMAND:

      switch(SHORT1FROMMP(mp1)){
         case DID_CAUSE:
         effect = WinWindowFromID(hwnd, DID_EFFECT);
         enabled = WinIsWindowEnabled(effect);
         enabled = !enabled;
         WinEnableWindow(effect, enabled);
         return 0;

         case DID_EFFECT:
         /* do something */
         return 0;

         case DID_OK:
         data = WinWindowFromID(hwnd, EF_DATA);
         WinQueryWindowText(data, 1000, local);
         strcpy(client, local);
         break; /* let WinDefDlg dismiss the dialog */
         }
         
      }

   return WinDefDlgProc(hwnd, msg, mp1, mp2);
   }
