#define INCL_GPI
#define INCL_WIN
#include <os2.h>

#include "buttons.h"

/* ClientWndProc is a dialog procedure */
MRESULT EXPENTRY ClientWndProc(HWND, ULONG, MPARAM, MPARAM);

int main (void)
{
   HAB   hab;                    /* anchor-block handle  */
   HMQ   hmq;                    /* message queue handle */
   HWND  hwndFrame;              /* handles to windows   */
   QMSG  qmsg;                   /* message              */
   char  szClassName[] = "Button Testing Program";
   BOOL  fail = FALSE;

   hab = WinInitialize(0);
   hmq = WinCreateMsgQueue(hab, 0);

   if (!WinRegisterClass(hab, szClassName, ClientWndProc,
                    CS_SIZEREDRAW, 0))
                    fail = TRUE;

   hwndFrame = WinLoadDlg(HWND_DESKTOP, HWND_DESKTOP,
                ClientWndProc, 0, BUTTONSPROGRAMID, NULL);
 
   if ((fail) || (hab==NULLHANDLE) ||
       (hmq==NULLHANDLE) || (hwndFrame==NULLHANDLE))
       WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
              "Unable to initialize application.", "ERROR!",
              0, MB_CANCEL | MB_ERROR);
   else
      while (WinGetMsg(hab, &qmsg, 0, 0, 0))
      WinDispatchMsg(hab, &qmsg);


   WinDestroyWindow(hwndFrame);
   WinDestroyMsgQueue(hmq);
   WinTerminate(hab);
   
   return 0;
   }

MRESULT EXPENTRY ClientWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   static int b = FALSE;
   /*event handler*/
   switch(msg) {

      case WM_CONTROL:
         WinSendDlgItemMsg(hwnd, CID_CHECK, BM_SETCHECK, MPFROMSHORT(b), 0);
         return 0;

      case WM_COMMAND:
         switch(SHORT1FROMMP(mp1)) {
            case PID_PLAIN:
            WinSendDlgItemMsg(hwnd, PID_HILITE, BM_CLICK, 0, 0);
            return 0;

            case PID_HILITE:
            if (WinQueryButtonCheckstate(hwnd, RID_PLANES))
               WinMessageBox(HWND_DESKTOP, hwnd, 
                        "Take a plane!", "", 0,0);
            else WinMessageBox(HWND_DESKTOP, hwnd,
                        "Take a hike!", "", 0,0);
            return 0;
            }

      case WM_CLOSE:
      WinPostMsg(hwnd, WM_QUIT, 0,0);
      return 0;
      }
 
   return WinDefDlgProc(hwnd, msg, mp1, mp2);
   }

