#define INCL_GPI
#define INCL_WIN
#define INCL_LISTBOXES
#include <os2.h>


#include "listbox.h"

MRESULT EXPENTRY ClientWndProc(HWND, ULONG, MPARAM, MPARAM);

int main (void)
{
   HAB   hab;                    /* anchor-block handle  */
   HMQ   hmq;                    /* message queue handle */
   HWND  hwndFrame;              /* handles to windows   */
   QMSG  qmsg;                   /* message              */
   char  szClassName[] = "Control Testing Program I";
   BOOL  fail = FALSE;

   LBOXINFO lbi;
   int i;
   PSZ *item[5] = {"Item 1","Item 2", "Item 3", "Item 4", "Item 5"};

   hab = WinInitialize(0);
   hmq = WinCreateMsgQueue(hab, 0);


   if (!WinRegisterClass(hab, szClassName, ClientWndProc,
                    CS_SIZEREDRAW, 0))
                    fail = TRUE;

   hwndFrame = WinLoadDlg(HWND_DESKTOP, HWND_DESKTOP,
                ClientWndProc, 0, LISTBOXPROGRAMID, NULL);
 
   for (i = 0; i < 5 ; i = i + 1 ) {
      WinSendDlgItemMsg(hwndFrame, LID_MULT, LM_INSERTITEM,
                        MPFROMSHORT(LIT_END), MPFROMP(item[i]));
      }

   memset(&lbi, 0, sizeof(lbi));
   lbi.lItemIndex = LIT_SORTDESCENDING;
   lbi.ulItemCount = 5;
   WinSendDlgItemMsg(hwndFrame, LID_EXT, LM_INSERTMULTITEMS,
                        MPFROMP(&lbi), MPFROMP(item));

   if ((fail) || (hab==NULLHANDLE) ||
       (hmq==NULLHANDLE) || (hwndFrame==NULLHANDLE))
       WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
              "Unable to initialize application.", "ERROR!",
              0, MB_CANCEL | MB_ERROR);
   else
      while (WinGetMsg(hab, &qmsg, 0, 0, 0))
      WinDispatchMsg(hab, &qmsg);


   WinDestroyWindow(hwndFrame);
   WinDestroyMsgQueue(hmq);
   WinTerminate(hab);
   
   return 0;
   }

MRESULT EXPENTRY ClientWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   int    i = LIT_FIRST;
   MPARAM mp;
   char   c[1000];

   /*event handler*/
   switch(msg) {

      case WM_COMMAND:

      switch(SHORT1FROMMP(mp1)) {

         case PID_SEARCH:
         mp = WinSendDlgItemMsg(hwnd, LID_EXT,
                LM_SEARCHSTRING, 
                MPFROM2SHORT(LSS_CASESENSITIVE, LIT_FIRST),
                MPFROMP("Item"));
         i = SHORT1FROMMP(mp);
         sprintf(c, "%d in LID_EXT contains 'item'.", i);
         if (i != LIT_NONE)
            WinMessageBox(HWND_DESKTOP, hwnd, 
                c, "FOUND!", 0, 0);
         return 0;

         case PID_QUERY:
         do {
            mp = WinSendDlgItemMsg(hwnd, LID_MULT,
               LM_QUERYSELECTION, MPFROMSHORT(i), 0);
            i = SHORT1FROMMP(mp);
            if (i != LIT_NONE) {
               WinSendDlgItemMsg(hwnd, LID_MULT, 
                   LM_QUERYITEMTEXT, MPFROM2SHORT(i, 1000),
                   MPFROMP(c));
               WinSendDlgItemMsg(hwnd, LID_MULTEXT,
                   LM_INSERTITEM, MPFROMSHORT(LIT_END), 
                    MPFROMP(c));
                }
            } while (i != LIT_NONE); /* enddo */
         return 0;
         }
      break;

      case WM_CLOSE:
      WinPostMsg(hwnd, WM_QUIT, 0,0);
      return 0;
      }
 
   return WinDefDlgProc(hwnd, msg, mp1, mp2);
   }

