#define INCL_GPI
#define INCL_WIN
#include <os2.h>

#include "slider.h"

/* ClientWndProc is a dialog procedure */
MRESULT EXPENTRY ClientWndProc(HWND, ULONG, MPARAM, MPARAM);

int main (void)
{
   HAB   hab;                    /* anchor-block handle  */
   HMQ   hmq;                    /* message queue handle */
   HWND  hwndDlg;                /* handles to windows   */
   QMSG  qmsg;                   /* message              */
   char  szClassName[] = "Sliding Into Home";
   BOOL  fail = FALSE;

   HWND    slider;
   int     i,j;
   MRESULT mr;

   hab = WinInitialize(0);
   hmq = WinCreateMsgQueue(hab, 0);

   if (!WinRegisterClass(hab, szClassName, ClientWndProc,
                    CS_SIZEREDRAW, 0))
                    fail = TRUE;

   hwndDlg = WinLoadDlg(HWND_DESKTOP, HWND_DESKTOP,
                ClientWndProc, 0, SLIDERPROGRAMID, NULL);

   slider = WinWindowFromID(hwndDlg, SL_SLIDER);
/*
   WinSendMsg(slider, SLM_SETTICKSIZE,
        MPFROM2SHORT(SMA_SETALLTICKS, 10), 0);
*/
   for (i=0;i<37;i=i+1) {
         
      j = 2;
      if (((i+1)%3)==0)   j=5;
      if (((i+1)%6)==0)   j=10;
      if (((i+1)%12)==0)  j=20;

      WinSendMsg(slider, SLM_SETTICKSIZE,
        MPFROM2SHORT(i, j), 0);
      }

   if (!WinSendMsg(slider, SLM_SETSCALETEXT,
        MPFROMSHORT(11), MPFROMP("1")));

   if (!WinSendMsg(slider, SLM_SETSCALETEXT,
        MPFROMSHORT(23), MPFROMP("2")));

   if (!WinSendMsg(slider, SLM_SETSCALETEXT,
        MPFROMSHORT(35), MPFROMP("3")));

   mr = WinSendMsg(slider, SLM_QUERYSLIDERINFO,
        MPFROMSHORT(SMA_SHAFTDIMENSIONS),
        0);
   i = SHORT1FROMMR(mr);

   WinSendDlgItemMsg(hwndDlg, SP_SPIN, SPBM_SETLIMITS,
                        MPFROMLONG(i), MPFROMLONG(0));

   if ((fail) || (hab==NULLHANDLE) ||
       (hmq==NULLHANDLE) || (hwndDlg==NULLHANDLE))
       WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
              "Unable to initialize application.", "ERROR!",
              0, MB_CANCEL | MB_ERROR);
   else
      while (WinGetMsg(hab, &qmsg, 0, 0, 0))
      WinDispatchMsg(hab, &qmsg);


   WinDestroyWindow(hwndDlg);
   WinDestroyMsgQueue(hmq);
   WinTerminate(hab);
   
   return 0;
   }

MRESULT EXPENTRY ClientWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   MRESULT mr;
   SHORT   sap;
   char    message[1000];

   /*event handler*/
   switch(msg) {

      case WM_CONTROL:
      switch(SHORT2FROMMP(mp1)) {
         case SLN_CHANGE:
         case SLN_SLIDERTRACK:
         WinSendDlgItemMsg(hwnd, SP_SPIN, 
                SPBM_SETCURRENTVALUE,mp2,0);
         return 0;
         }

      case WM_COMMAND:
      switch(SHORT1FROMMP(mp1)) {
         case PB_QUERY:
         mr = WinSendDlgItemMsg(hwnd, SL_SLIDER, SLM_QUERYSLIDERINFO,
           MPFROM2SHORT(SMA_SLIDERARMPOSITION, SMA_INCREMENTVALUE),
           0);
         sap = SHORT1FROMMR(mr);
         sprintf(message,"Slider arm at increment %d",sap);
         WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
              message, "Query Slider Arm",
              0, MB_OK | MB_INFORMATION);

         return 0;
         }
      break;

      case WM_CLOSE:
      WinPostMsg(hwnd, WM_QUIT, 0,0);
      return 0;
      }
 
   return WinDefDlgProc(hwnd, msg, mp1, mp2);
   }

