#define INCL_GPI
#define INCL_WIN
#include <os2.h>

#include "valset.h"

/* ClientWndProc is a dialog procedure */
MRESULT EXPENTRY ClientWndProc(HWND, ULONG, MPARAM, MPARAM);

int main (void)
{
   HAB   hab;                    /* anchor-block handle  */
   HMQ   hmq;                    /* message queue handle */
   HWND  hwndDlg;                /* handles to windows   */
   QMSG  qmsg;                   /* message              */
   char  szClassName[] = "Value Sets";
   BOOL  fail = FALSE;

   int   i,j;
   char  txt[1000];

   hab = WinInitialize(0);
   hmq = WinCreateMsgQueue(hab, 0);
 
   if (!WinRegisterClass(hab, szClassName, ClientWndProc,
                    CS_SIZEREDRAW, 0))
                    fail = TRUE;

   hwndDlg = WinLoadDlg(HWND_DESKTOP, HWND_DESKTOP,
                ClientWndProc, 0, VALSETPROGRAMID, NULL);

   for (i=1;i<=8;i=i+1 ) {
      for (j=1;j<=8;j=j+1) {
         sprintf(txt, "%d", ((i-1)*8)+j);
         WinSendDlgItemMsg(hwndDlg, VS_LRS, VM_SETITEM,
            MPFROM2SHORT(i,j),txt);
      } 
   } 

   WinSendDlgItemMsg(hwndDlg, VS_SRS, VM_SETITEM,
        MPFROM2SHORT(1,1), MPFROMP(
        WinGetSysBitmap(HWND_DESKTOP, SBMP_SBUPARROW)));

   WinSendDlgItemMsg(hwndDlg, VS_SRS, VM_SETITEMATTR,
        MPFROM2SHORT(2,2), 
        MPFROM2SHORT(VIA_COLORINDEX, TRUE));

   WinSendDlgItemMsg(hwndDlg, VS_SRS, VM_SETITEM,
        MPFROM2SHORT(2,2), 
        MPFROMLONG(1));

   WinSendDlgItemMsg(hwndDlg, VS_SRS, VM_SETITEMATTR,
        MPFROM2SHORT(3,3),
        MPFROM2SHORT(VIA_ICON, TRUE));

   WinSendDlgItemMsg(hwndDlg, VS_SRS, VM_SETITEM, 
        MPFROM2SHORT(3,3), MPFROMP(
        WinQuerySysPointer(HWND_DESKTOP, SPTR_WAIT, TRUE)));

   WinSendDlgItemMsg(hwndDlg, VS_SRS, VM_SETITEMATTR,
        MPFROM2SHORT(4,4),
        MPFROM2SHORT(VIA_RGB, TRUE));

   WinSendDlgItemMsg(hwndDlg, VS_SRS, VM_SETITEM,
        MPFROM2SHORT(4,4),
        MPFROMLONG(65000));

   WinSendDlgItemMsg(hwndDlg, VS_SRS, VM_SETITEMATTR,
        MPFROM2SHORT(5,5),
        MPFROM2SHORT(VIA_TEXT | VIA_DISABLED, TRUE));

   WinSendDlgItemMsg(hwndDlg, VS_SRS, VM_SETITEM,
        MPFROM2SHORT(5,5),
        MPFROMP("!"));

   WinSendDlgItemMsg(hwndDlg, SP_ROW, SPBM_SETLIMITS,
                        MPFROMLONG(8), MPFROMLONG(1));
   WinSendDlgItemMsg(hwndDlg, SP_COL, SPBM_SETLIMITS,
                        MPFROMLONG(8), MPFROMLONG(1));

   if ((fail) || (hab==NULLHANDLE) ||
       (hmq==NULLHANDLE) || (hwndDlg==NULLHANDLE))
       WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
              "Unable to initialize application.", "ERROR!",
              0, MB_CANCEL | MB_ERROR);
   else
      while (WinGetMsg(hab, &qmsg, 0, 0, 0))
      WinDispatchMsg(hab, &qmsg);


   WinDestroyWindow(hwndDlg);
   WinDestroyMsgQueue(hmq);
   WinTerminate(hab);
   
   return 0;
   }

MRESULT EXPENTRY ClientWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   char    message[1000];
   MRESULT mr;
   USHORT  srow, scol, lrow, lcol;

   /*event handler*/
   switch(msg) {
 
      case WM_COMMAND:
      switch(SHORT1FROMMP(mp1)){
         case PB_QUERY:
         mr = WinSendDlgItemMsg(hwnd, VS_LRS, 
                VM_QUERYSELECTEDITEM, 0,0);
         lrow = SHORT1FROMMR(mr);
         lcol = SHORT2FROMMR(mr);

         mr = WinSendDlgItemMsg(hwnd, VS_SRS,
                VM_QUERYSELECTEDITEM, 0,0);
         srow = SHORT1FROMMR(mr);
         scol = SHORT2FROMMR(mr);

         sprintf(message, "Long range at %d, %d.\n\
Short range at %d, %d", lrow, lcol, srow, scol);

         WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
              message, "Response", 0, MB_OK | MB_INFORMATION);
 
         return 0;
         }

      case WM_CONTROL:
      switch(SHORT2FROMMP(mp1)){
         case VN_ENTER:
         sprintf(message, "Entry/Dbl click at %d, %d",
                SHORT1FROMMP(mp2),
                SHORT2FROMMP(mp2));

         WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
              message, "Selection", 0, MB_OK | MB_INFORMATION);
 
         return 0;

         case VN_SELECT:
         WinSendDlgItemMsg(hwnd, SP_ROW, SPBM_SETCURRENTVALUE,
                MPFROMSHORT(SHORT1FROMMP(mp2)),0);
         WinSendDlgItemMsg(hwnd, SP_COL, SPBM_SETCURRENTVALUE,
                MPFROMSHORT(SHORT2FROMMP(mp2)),0);
         return 0;
         }
      break;

      case WM_CLOSE:
      WinPostMsg(hwnd, WM_QUIT, 0,0);
      return 0;
      }
 
   return WinDefDlgProc(hwnd, msg, mp1, mp2);
   }

