#define INCL_GPI
#define INCL_WIN
#include <os2.h>
#include <string.h>

#include "GPI.h"

MRESULT EXPENTRY ClientWndProc(HWND, ULONG, MPARAM, MPARAM);

#define APPNORMAL    0
#define INITFAILURE -1
#define USERQUIT    -2

typedef struct {
   HPS          hpm;
   HDC          hdc;
   HBITMAP      hbmp;
   BOOL         first;
   int          px, py, ox, oy;
   } WINDOWDATA;

typedef WINDOWDATA *PWINDOWDATA;


int main (void)
{
   HAB   hab;                    /* anchor-block handle  */
   HMQ   hmq;                    /* message queue handle */
   HWND  hwndFrame, hwndClient;  /* handles to windows   */
   QMSG  qmsg;                   /* message              */
   char  szClassName[] = "Juster";
   char  szWindowTitle[] = "To The Vector Go The Spoils";
   ULONG flFrameOpts = FCF_STANDARD;
   ULONG appState = APPNORMAL;
 
   hab = WinInitialize(0);
   hmq = WinCreateMsgQueue(hab, 0);

   if (!WinRegisterClass(hab, szClassName, ClientWndProc,
                    CS_SIZEREDRAW, 4))
             appState = INITFAILURE;
   hwndFrame = WinCreateStdWindow(HWND_DESKTOP, WS_VISIBLE,
                                &flFrameOpts, szClassName,
                                szWindowTitle, 0L, 0, 
                                GPIPROGRAMID,
                                &hwndClient);

   WinStartTimer(hab, hwndClient, 0, 0);

   if ((appState==INITFAILURE) || (hab==NULLHANDLE) ||
       (hmq==NULLHANDLE) || (hwndFrame==NULLHANDLE))
       WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
              "Unable to initialize application.", "ERROR!",
              0, MB_CANCEL | MB_ERROR);
   else 
   while (appState==APPNORMAL) {

      while (WinGetMsg(hab, &qmsg, 0, 0, 0))
      WinDispatchMsg(hab, &qmsg);

      if (WinSendMsg(hwndClient, WM_COMMAND, 
         MPFROM2SHORT(CMD_VERIFY, 0), 0) != MBID_CANCEL)
         appState = USERQUIT;

      if (qmsg.hwnd == NULLHANDLE) /*system shutdown */
         if (appState != USERQUIT) WinCancelShutdown(hmq, FALSE);

      }

   WinDestroyWindow(hwndFrame);
   WinDestroyMsgQueue(hmq);
   WinTerminate(hab);
   
   return 0;
   }

MRESULT EXPENTRY ClientWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{                         
   HPS     hps;
   RECTL   rcl;
   ULONG   cmd;
   PPOINTL pt;
   POINTL  ptl;      
   int     i;
   SIZEL   size;
   HAB     hab;
   PWINDOWDATA wd;
  
   /*event handler*/
   switch(msg) {

      case WM_CREATE:
      wd = (PWINDOWDATA)calloc(1, sizeof(WINDOWDATA));
      WinSetWindowPtr(hwnd, 0, wd);
      hab = WinQueryAnchorBlock(hwnd);
      wd->hdc = DevOpenDC(hab, OD_MEMORY, "*", 0, NULLHANDLE, 0);
      size.cx = 0;
      size.cy = 0;
      wd->hpm = GpiCreatePS(hab, wd->hdc, &size,
        PU_PELS | GPIF_DEFAULT | GPIT_MICRO | GPIA_ASSOC);
      wd->hbmp = GpiLoadBitmap(wd->hpm, 0, THEDOT, 0,0);
      GpiSetBitmap(wd->hpm, wd->hbmp);
      wd->first = TRUE;                
      wd->px = 4; wd->py = 4; wd->ox = 1; wd->oy = 1;
      return 0;     

      case WM_SIZE:
      case WM_SHOW:
      case WM_ACTIVATE:
      wd = WinQueryWindowPtr(hwnd, 0);
      wd->first = TRUE;
      WinInvalidateRect(hwnd, NULL, TRUE);
      return 0;

      case WM_PAINT:
      wd = WinQueryWindowPtr(hwnd, 0);
      hps = WinBeginPaint(hwnd, NULLHANDLE, NULLHANDLE);      
      WinQueryWindowRect(hwnd, &rcl);

      if (wd->first) {   
         GpiErase(hps);

         pt = (PPOINTL)malloc(100 * sizeof(POINTL));

         if (pt!=NULL)
         for (i = 0; i < 100; i = i +1) {
            pt[i].x = rand() % rcl.xRight;
            pt[i].y = rand() % rcl.yTop;
            }

         GpiSetColor(hps, CLR_DARKCYAN); 
   /*    GpiSetLineType(hps, LINETYPE_DASHDOUBLEDOT); */
         GpiMove(hps, pt);
         GpiPolyLine(hps, 99, pt+1);
         }
/* in this scenario, hbmp is a local variable */
/*
      hbmp = GpiLoadBitmap(hps, 0, THEDOT, 0,0);
      ptl.x = 0; ptl.y =0;
      WinDrawBitmap(hps, hbmp, NULL, &ptl, 0,0, DBM_NORMAL);
 */
      pt = (PPOINTL)malloc(4 * sizeof(POINTL));

      if(!wd->first) {
         pt[0].x = wd->ox;    /* target */
         pt[0].y = wd->oy;    /* origin */

         pt[1].x = wd->ox+32; /* target */
         pt[1].y = wd->oy+32; /* extent */

         pt[2].x = 0;         /* source */
         pt[2].y = 0;         /* origin */
         GpiBitBlt(hps, wd->hpm, 3, pt, ROP_SRCINVERT, BBO_IGNORE);

         if ((pt[0].x <= rcl.xLeft) || (pt[0].x >= (rcl.xRight-32)))
                wd->px = -wd->px;
         wd->ox = wd->ox + wd->px;
         if ((pt[0].y <= rcl.yBottom) || (pt[0].y >= (rcl.yTop-32)))
                wd->py = -wd->py;
         wd->oy = wd->oy + wd->py;

         }

      pt[0].x = wd->ox;    /* target */
      pt[0].y = wd->oy;    /* origin */

      pt[1].x = wd->ox+32; /* target */
      pt[1].y = wd->oy+32; /* extent */

      pt[2].x = 0;         /* source */
      pt[2].y = 0;         /* origin */
      GpiBitBlt(hps, wd->hpm, 3, pt, ROP_SRCINVERT, BBO_IGNORE);
      wd->first = FALSE;

      WinEndPaint(hps);
      return 0;

      case WM_TIMER:
      WinInvalidateRect(hwnd, NULL, TRUE);
      return 0;

      case WM_COMMAND:

      switch(SHORT1FROMMP(mp1)) {
         case CMD_VERIFY:
         cmd = MBID_NO;                                
         /* if (data_modified) */ {
            cmd = WinMessageBox(HWND_DESKTOP, hwnd,
                "Do you want to save your work before exiting?",
                "Query", 0, MB_YESNOCANCEL | MB_QUERY);
            /* if cmd==MB_YES save_data */
            } 
         return (MRESULT)cmd;
 
         /* case CMD_OTHERCOMMANDS: */

         } /* end WM_COMMAND messages */
      break;

      case WM_DESTROY:              
      wd = WinQueryWindowPtr(hwnd, 0);
      GpiDestroyPS(wd->hpm);
      DevCloseDC(wd->hdc);
      GpiDeleteBitmap(wd->hbmp);
      free(wd);
      return 0;

      } /*end event handlers */

   return WinDefWindowProc(hwnd, msg, mp1, mp2);
   }
