#define INCL_GPI
#define INCL_WIN
#include <os2.h>
#include <string.h>

#include "font.h"

MRESULT EXPENTRY ClientWndProc(HWND, ULONG, MPARAM, MPARAM);

#define APPNORMAL    0
#define INITFAILURE -1
#define USERQUIT    -2

int main (void)
{
   HAB   hab;                    /* anchor-block handle  */
   HMQ   hmq;                    /* message queue handle */
   HWND  hwndFrame, hwndClient;  /* handles to windows   */
   QMSG  qmsg;                   /* message              */
   char  szClassName[] = "Fonts";
   char  szWindowTitle[] = "Testing FONT Gpi";
   ULONG flFrameOpts = FCF_STANDARD;
   ULONG appState = APPNORMAL;
 
   hab = WinInitialize(0);
   hmq = WinCreateMsgQueue(hab, 0);

   if (!WinRegisterClass(hab, szClassName, ClientWndProc,
                    CS_SIZEREDRAW, 0)) 
             appState = INITFAILURE;
   hwndFrame = WinCreateStdWindow(HWND_DESKTOP, WS_VISIBLE,
                                &flFrameOpts, szClassName,
                                szWindowTitle, 0L, 0, 
                                FONTPROGRAMID,
                                &hwndClient);

   if ((appState==INITFAILURE) || (hab==NULLHANDLE) ||
       (hmq==NULLHANDLE) || (hwndFrame==NULLHANDLE))
       WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
              "Unable to initialize application.", "ERROR!",
              0, MB_CANCEL | MB_ERROR);
   else 
   while (appState==APPNORMAL) {

      while (WinGetMsg(hab, &qmsg, 0, 0, 0))
      WinDispatchMsg(hab, &qmsg);

      if (WinSendMsg(hwndClient, WM_COMMAND, 
         MPFROM2SHORT(CMD_VERIFY, 0), 0) != MBID_CANCEL)
         appState = USERQUIT;

      if (qmsg.hwnd == NULLHANDLE) /*system shutdown */
         if (appState != USERQUIT) WinCancelShutdown(hmq, FALSE);

      }

   WinDestroyWindow(hwndFrame);
   WinDestroyMsgQueue(hmq);
   WinTerminate(hab);
   
   return 0;
   }

MRESULT EXPENTRY ClientWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{                         
   HPS          hps;
   RECTL        rcl;
   ULONG        cmd;
   POINTL       ptl, ptl2, query[TXTBOX_COUNT], box[5];
   FATTRS       fat;
   FONTMETRICS  fm;
   SIZEF        fs;
   int          i;

   /*event handler*/
   switch(msg) {

      case WM_PAINT:
      hps = WinBeginPaint(hwnd, NULLHANDLE, NULLHANDLE);
      WinQueryWindowRect(hwnd, &rcl);
      WinFillRect(hps, &rcl, CLR_WHITE); 

      memset(&fat, 0, sizeof(FATTRS));

      /* raster font */
      fat.usRecordLength = sizeof(FATTRS);
      fat.lMaxBaselineExt = 12;
      fat.lAveCharWidth = 12;
      strcpy(fat.szFacename, "Courier");
      fat.fsFontUse = FATTR_FONTUSE_NOMIX;
 
      GpiCreateLogFont(hps, NULL, 1, &fat);
      GpiSetCharSet(hps, 1);
      GpiQueryFontMetrics(hps, sizeof fm, &fm);

      ptl.x = rcl.xLeft;
      ptl.y = rcl.yTop - fm.lMaxAscender;
      GpiCharStringAt(hps, &ptl, 20, "A Font of my Youth.");
      GpiQueryTextBox(hps, 20, "A Font of my Youth.", 
        TXTBOX_COUNT, query);

      box[0] = query[TXTBOX_BOTTOMLEFT];
      box[1] = query[TXTBOX_TOPLEFT];
      box[2] = query[TXTBOX_TOPRIGHT];
      box[3] = query[TXTBOX_BOTTOMRIGHT];
      box[4] = box[0];
 
      for (i=0;i<5;i=i+1) {
         box[i].x = box[i].x + ptl.x;
         box[i].y = box[i].y + ptl.y;
         }

      GpiMove(hps, box);
      GpiPolyLine(hps, 4, box+1);
 
      /* outline font */
      GpiDeleteSetId(hps, 1);
      fat.fsSelection = 0; /*FATTR_SEL_OUTLINE;*/
      fat.lMaxBaselineExt = 0;
      fat.lAveCharWidth = 0;
      strcpy(fat.szFacename ,"Courier");
      fat.fsFontUse = FATTR_FONTUSE_NOMIX | FATTR_FONTUSE_OUTLINE | FATTR_FONTUSE_TRANSFORMABLE;

      GpiCreateLogFont(hps, NULL, 1, &fat);
      GpiSetCharSet(hps, 1);

      GpiSetCharMode(hps, CM_MODE3);
      ptl.x = rcl.xRight; ptl.y = rcl.yTop;
      ptl2.x = -rcl.xRight;
      ptl2.y = -rcl.yTop;
      GpiSetCharAngle(hps, &ptl2);
      fs.cx = MAKEFIXED(75, 0);
      fs.cy = MAKEFIXED(75, 0);
      GpiSetCharBox(hps, &fs); 
      GpiCharStringAt(hps, &ptl, 20, "A Font of my Youth.");

      WinEndPaint(hps);
      return 0;


      case WM_COMMAND:

      switch(SHORT1FROMMP(mp1)) {
         case CMD_VERIFY:
         cmd = MBID_NO;                                
         /* if (data_modified) */ {
            cmd = WinMessageBox(HWND_DESKTOP, hwnd,
                "Do you want to save your work before exiting?",
                "Query", 0, MB_YESNOCANCEL | MB_QUERY);
            /* if cmd==MB_YES save_data */
            } 
         return (MRESULT)cmd;
 
         /* case CMD_OTHERCOMMANDS: */

         } /* end WM_COMMAND messages */

      } /*end event handlers */
   return WinDefWindowProc(hwnd, msg, mp1, mp2);
   }
