#define INCL_DOS
#define INCL_GPI
#define INCL_WIN
#include <os2.h>
#include <string.h>

#include "thread.h"

MRESULT EXPENTRY ClientWndProc(HWND, ULONG, MPARAM, MPARAM);
VOID _System countfn(LONG param);

#define APPNORMAL    0
#define INITFAILURE -1
#define USERQUIT    -2

typedef struct {
   LONG   passes;
   LONG   progress;
   BOOL   update;
   BOOL   done;
   PSZ    text;
   HEV    sem1, sem2;
   BOOL   ip;
   } SHARED;

typedef SHARED *PSHARED;


int main (void)
{
   HAB   hab;                    /* anchor-block handle  */
   HMQ   hmq;                    /* message queue handle */
   HWND  hwndFrame, hwndClient;  /* handles to windows   */
   QMSG  qmsg;                   /* message              */
   char  szClassName[] = "Multi-threading!!!!!!!";
   char  szWindowTitle[] = "Thread It, Baby!";
   ULONG flFrameOpts = FCF_STANDARD;
   ULONG appState = APPNORMAL;

   PSHARED wd;
 
   hab = WinInitialize(0);
   hmq = WinCreateMsgQueue(hab, 0);

   if (!WinRegisterClass(hab, szClassName, ClientWndProc,
                    CS_SIZEREDRAW, 4))
             appState = INITFAILURE;
   hwndFrame = WinCreateStdWindow(HWND_DESKTOP, WS_VISIBLE,
                                &flFrameOpts, szClassName,
                                szWindowTitle, 0L, 0, 
                                THREADPROGRAMID,
                                &hwndClient);

   wd = (PSHARED)malloc(sizeof(SHARED));
   wd->done = FALSE;
   wd->update = FALSE;
   wd->progress = 0;
   wd->passes = 0;
   wd->text = (PSZ)malloc(1000);
   wd->sem1 = 0;
   wd->sem2 = 0;
   wd->ip = FALSE;

   WinSetWindowPtr(hwndClient, 0, wd);

   if ((appState==INITFAILURE) || (hab==NULLHANDLE) ||
       (hmq==NULLHANDLE) || (hwndFrame==NULLHANDLE))
       WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
              "Unable to initialize application.", "ERROR!",
              0, MB_CANCEL | MB_ERROR);
   else 
   while (appState==APPNORMAL) {

      while (WinGetMsg(hab, &qmsg, 0, 0, 0))
      WinDispatchMsg(hab, &qmsg);

      if (WinSendMsg(hwndClient, WM_COMMAND, 
         MPFROM2SHORT(CMD_VERIFY, 0), 0) != MBID_CANCEL)
         appState = USERQUIT;

      if (qmsg.hwnd == NULLHANDLE) /*system shutdown */
         if (appState != USERQUIT) WinCancelShutdown(hmq, FALSE);

      }

   WinDestroyWindow(hwndFrame);
   WinDestroyMsgQueue(hmq);
   WinTerminate(hab);
   
   return 0;
   }

MRESULT EXPENTRY ClientWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{                         
   HPS          hps;
   RECTL        rcl;
   ULONG        cmd;
   TID          tid;
   PFN          pfn = &countfn;
   PSHARED      wd;
   ULONG        posts;

   FONTMETRICS  fm;
   int          charHeight, len, written;
   /*event handler*/

   switch(msg) {

      case WM_PAINT:
      wd = WinQueryWindowPtr(hwnd, 0);
      hps = WinBeginPaint(hwnd, NULLHANDLE, NULLHANDLE);
      WinQueryWindowRect(hwnd, &rcl);
      if (!wd->update) WinFillRect(hps, &rcl, CLR_WHITE);
      else {
         GpiQueryFontMetrics(hps, sizeof(fm), &fm);
         charHeight = fm.lMaxBaselineExt;
         rcl.yBottom = rcl.yTop-charHeight;
         len = strlen(wd->text);
         written = 0;
         while (written < len) {
            written = written + WinDrawText(hps, -1, wd->text+written,
             &rcl, 0, 0, DT_TEXTATTRS | DT_WORDBREAK | DT_ERASERECT);
            rcl.yTop = rcl.yTop - charHeight;
            rcl.yBottom = rcl.yBottom - charHeight;
            if (rcl.yBottom < 0) break;
            } 
         wd->update = FALSE;
         }
      WinEndPaint(hps);
      return 0;


      case WM_COMMAND:
      wd = WinQueryWindowPtr(hwnd, 0);
      switch(SHORT1FROMMP(mp1)) {

         case CMD_PROGRESS:
         wd->update = TRUE;
         WinInvalidateRect(hwnd, NULL, 0);
         DosResetEventSem(wd->sem1, &posts);
         return 0;

         case CMD_DONE:
         wd = WinQueryWindowPtr(hwnd, 0);
         wd->ip = FALSE; 
         WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
              "Finished!", "Information!",
              0, MB_OK | MB_INFORMATION);
         DosCloseEventSem(wd->sem1);
         DosCloseEventSem(wd->sem2);
         WinSendMsg(
                WinWindowFromID(hwnd, THREADPROGRAMID),
                MM_SETITEMATTR,
                MPFROMSHORT(CMD_FILEDOIT),
                MPFROM2SHORT(MIA_DISABLED, 0));
         return 0;

         case CMD_FILEDOIT:
         wd = WinQueryWindowPtr(hwnd, 0);
         if (DosCreateEventSem(NULL, &(wd->sem1), 0, 0) != 0) {
            WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
                "Unable to create progress semaphore.", "Error!",
                0, MB_CANCEL | MB_ERROR);
            break;
            }
         if (DosCreateEventSem(NULL, &(wd->sem2), 0, 0) != 0) {
            WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
                "Unable to create finished semaphore.", "Error!",
                0, MB_CANCEL | MB_ERROR);
            DosCloseEventSem(wd->sem1);
            break;
            }
         if (DosCreateThread(&tid, pfn, hwnd, 0, 8192) != 0) {
         WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
              "Unable to create thread.", "ERROR!",
              0, MB_CANCEL | MB_ERROR);
            break;
            }
         WinSendMsg(
                WinWindowFromID(hwnd, THREADPROGRAMID),
                MM_SETITEMATTR,                        
                MPFROMSHORT(CMD_FILEDOIT),
                MPFROM2SHORT(MIA_DISABLED, MIA_DISABLED));
         wd->ip = TRUE;
         return 0;

         case CMD_VERIFY:
         cmd = MBID_NO;                                
         /* if (data_modified) */ {
            cmd = WinMessageBox(HWND_DESKTOP, hwnd,
                "Do you want to save your work before exiting?",
                "Query", 0, MB_YESNOCANCEL | MB_QUERY);
            /* if cmd==MB_YES save_data */
            } 
         return (MRESULT)cmd;
 
         /* case CMD_OTHERCOMMANDS: */

         } /* end WM_COMMAND messages */

      default:
      wd = WinQueryWindowPtr(hwnd, 0);
      if (wd==NULL) break;
      if (wd->ip) {
         DosQueryEventSem(wd->sem2, &posts);
         if (posts>0) {
            WinPostMsg(hwnd, WM_COMMAND, MPFROMSHORT(CMD_DONE), 0);
            break; 
            }
 
    /* don't bother to check the progress semaphore,
       if the done semaphore has been signalled */
 
         DosQueryEventSem(wd->sem1, &posts);
         if (posts>0)
            WinPostMsg(hwnd, WM_COMMAND, MPFROMSHORT(CMD_PROGRESS), 0);
         } 
      break;
      } /*end event handlers */

 
   return WinDefWindowProc(hwnd, msg, mp1, mp2);
   }

VOID _System countfn(HWND caller)
{
   LONG    counter = 0;
   PSHARED wd;
 
   PSZ     text = "\tRodrigo\nTush! never tell me; I take it much unkindly\nThat thou, Iago, who has had my purse\nAs if the strings were thine, shouldst know of this\n\tIago\n'Sblood, but you will not hear me:\n";

   wd = WinQueryWindowPtr(caller, 0);
   while(counter < strlen(text)) {                                                                                                                                                                                           
      DosSleep(50);
      counter = counter + 1;
      strncpy(wd->text, text, counter);
      DosPostEventSem(wd->sem1);
      }
 
   DosPostEventSem(wd->sem2);
   }

